library soccer_match;

import 'dart:convert';
import 'package:http/http.dart';
import 'package:intl/intl.dart';
import 'package:path_provider/path_provider.dart';
import 'dart:io';

class soccer_match {
  final String today = DateFormat('yyyy-MM-dd').format(DateTime.now());
  final category;
  soccer_match(this.category);

  Future<List<SoccerMatch>> getAllMatches(
      Map<String, dynamic> queryMatches) async {
    var body;
    String tempMatches = category.toString() +
        "_" +
        queryMatches['date'].toString() +
        'matches.json';
    var tempDir = await getApplicationDocumentsDirectory();
    File fileMatches = File(tempDir.path + "/football" + tempMatches);
    try {
      Uri uri = Uri.https(
          'elastad.com/web/api', '/football/$category.php', queryMatches);
      Response res = await get(uri);
      if (res.body.isNotEmpty && res.body[0].isNotEmpty) {
        if (res.statusCode == 200) {
          fileMatches.writeAsStringSync(res.body,
              flush: true, mode: FileMode.write);
          body = jsonDecode(res.body);
          List<dynamic> matchesList = body['response'];
          List<SoccerMatch> matches = matchesList
              .map((dynamic item) => SoccerMatch.fromJson(item))
              .toList();
          return matches;
        } else {
          if (fileMatches.existsSync()) {
            final data = fileMatches.readAsStringSync();
            body = jsonDecode(data);
            List<dynamic> matchesList = body['response'];
            List<SoccerMatch> matches = matchesList
                .map((dynamic item) => SoccerMatch.fromJson(item))
                .toList();
            return matches;
          } else {
            Uri uri = Uri.https(
                'btcdoller.co', '/football/$category.php', queryMatches);
            Response res = await get(uri);
            if (res.statusCode == 200) {
              fileMatches.writeAsStringSync(res.body,
                  flush: true, mode: FileMode.write);
              body = jsonDecode(res.body);
              List<dynamic> matchesList = body['response'];
              List<SoccerMatch> matches = matchesList
                  .map((dynamic item) => SoccerMatch.fromJson(item))
                  .toList();
              return matches;
            } else {
              List<SoccerMatch> mat = [];
              return mat;
            }
          }
        }
      } else {
        if (fileMatches.existsSync()) {
          final data = fileMatches.readAsStringSync();
          body = jsonDecode(data);
          List<dynamic> matchesList = body['response'];
          List<SoccerMatch> matches = matchesList
              .map((dynamic item) => SoccerMatch.fromJson(item))
              .toList();
          return matches;
        } else {
          Uri uri = Uri.https(
              'btcdoller.co', '/football/$category.php', queryMatches);
          Response res = await get(uri);
          if (res.statusCode == 200) {
            fileMatches.writeAsStringSync(res.body,
                flush: true, mode: FileMode.write);
            body = jsonDecode(res.body);
            List<dynamic> matchesList = body['response'];
            List<SoccerMatch> matches = matchesList
                .map((dynamic item) => SoccerMatch.fromJson(item))
                .toList();
            return matches;
          } else {
            List<SoccerMatch> mat = [];
            return mat;
          }
        }
      }
    } on SocketException catch (_) {
      if (fileMatches.existsSync()) {
        final data = fileMatches.readAsStringSync();
        body = jsonDecode(data);
        List<dynamic> matchesList = body['response'];
        List<SoccerMatch> matches = matchesList
            .map((dynamic item) => SoccerMatch.fromJson(item))
            .toList();
        return matches;
      } else {
        Uri uri =
            Uri.https('btcdoller.co', '/football/$category.php', queryMatches);
        Response res = await get(uri);
        if (res.statusCode == 200) {
          fileMatches.writeAsStringSync(res.body,
              flush: true, mode: FileMode.write);
          body = jsonDecode(res.body);
          List<dynamic> matchesList = body['response'];
          List<SoccerMatch> matches = matchesList
              .map((dynamic item) => SoccerMatch.fromJson(item))
              .toList();
          return matches;
        } else {
          List<SoccerMatch> mat = [];
          return mat;
        }
      }
    }
  }
}

class SoccerMatch {
  Fixture? fixture;
  League? league;
  Teams? teams;
  Goals? goals;
  Score? score;

  SoccerMatch({this.fixture, this.league, this.teams, this.goals, this.score});

  SoccerMatch.fromJson(Map<String, dynamic> json) {
    fixture =
        json['fixture'] != null ? new Fixture.fromJson(json['fixture']) : null;
    league =
        json['league'] != null ? new League.fromJson(json['league']) : null;
    teams = json['teams'] != null ? new Teams.fromJson(json['teams']) : null;
    goals = json['goals'] != null ? new Goals.fromJson(json['goals']) : null;
    score = json['score'] != null ? new Score.fromJson(json['score']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.fixture != null) {
      data['fixture'] = this.fixture!.toJson();
    }
    if (this.league != null) {
      data['league'] = this.league!.toJson();
    }
    if (this.teams != null) {
      data['teams'] = this.teams!.toJson();
    }
    if (this.goals != null) {
      data['goals'] = this.goals!.toJson();
    }
    if (this.score != null) {
      data['score'] = this.score!.toJson();
    }
    return data;
  }
}

class Score {
  Goals? halftime;
  Goals? fulltime;
  Goals? extratime;
  Penalty? penalty;

  Score({this.halftime, this.fulltime, this.extratime, this.penalty});

  Score.fromJson(Map<String, dynamic> json) {
    halftime =
        json['halftime'] != null ? new Goals.fromJson(json['halftime']) : null;
    fulltime =
        json['fulltime'] != null ? new Goals.fromJson(json['fulltime']) : null;
    extratime = json['extratime'] != null
        ? new Goals.fromJson(json['extratime'])
        : null;
    penalty =
        json['penalty'] != null ? new Penalty.fromJson(json['penalty']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.halftime != null) {
      data['halftime'] = this.halftime!.toJson();
    }
    if (this.fulltime != null) {
      data['fulltime'] = this.fulltime!.toJson();
    }
    if (this.extratime != null) {
      data['extratime'] = this.extratime!.toJson();
    }
    if (this.penalty != null) {
      data['penalty'] = this.penalty!.toJson();
    }
    return data;
  }
}

class Penalty {
  Teams? home;
  Teams? away;

  Penalty({this.home, this.away});

  Penalty.fromJson(Map<String, dynamic> json) {
    home = json['home'];
    away = json['away'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['home'] = this.home;
    data['away'] = this.away;
    return data;
  }
}

class Extratime {
  int home;
  int away;
  Extratime({required this.home, required this.away});

  //Now we will create a factory method to copy the data from
  // the json file
  factory Extratime.fromJson(Map<String, dynamic> json) {
    return Extratime(home: json['home'], away: json['away']);
  }
}

class Fulltime {
  int home;
  int away;
  Fulltime({required this.home, required this.away});

  //Now we will create a factory method to copy the data from
  // the json file
  factory Fulltime.fromJson(Map<String, dynamic> json) {
    return Fulltime(home: json['home'], away: json['away']);
  }
}

class Halftime {
  int home;
  int away;
  Halftime({required this.home, required this.away});

  //Now we will create a factory method to copy the data from
  // the json file
  factory Halftime.fromJson(Map<String, dynamic> json) {
    return Halftime(home: json['home'], away: json['away']);
  }
}

class Fixture {
  int? id;
  String? referee;
  String? timezone;
  String? date;
  int? timestamp;
  Periods? periods;
  Venue? venue;
  Status? status;

  Fixture(
      {this.id,
      this.referee,
      this.timezone,
      this.date,
      this.timestamp,
      this.periods,
      this.venue,
      this.status});

  Fixture.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    referee = json['referee'];
    timezone = json['timezone'];
    date = json['date'];
    timestamp = json['timestamp'];
    periods =
        json['periods'] != null ? new Periods.fromJson(json['periods']) : null;
    venue = json['venue'] != null ? new Venue.fromJson(json['venue']) : null;
    status =
        json['status'] != null ? new Status.fromJson(json['status']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['referee'] = this.referee;
    data['timezone'] = this.timezone;
    data['date'] = this.date;
    data['timestamp'] = this.timestamp;
    if (this.periods != null) {
      data['periods'] = this.periods!.toJson();
    }
    if (this.venue != null) {
      data['venue'] = this.venue!.toJson();
    }
    if (this.status != null) {
      data['status'] = this.status!.toJson();
    }
    return data;
  }
}

class Teams {
  Home? home;
  Home? away;

  Teams({this.home, this.away});

  Teams.fromJson(Map<String, dynamic> json) {
    home = json['home'] != null ? new Home.fromJson(json['home']) : null;
    away = json['away'] != null ? new Home.fromJson(json['away']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.home != null) {
      data['home'] = this.home!.toJson();
    }
    if (this.away != null) {
      data['away'] = this.away!.toJson();
    }
    return data;
  }
}

//here we will store the Goal data
class Goals {
  int? home;
  int? away;

  Goals({this.home, this.away});

  Goals.fromJson(Map<String, dynamic> json) {
    home = json['home'];
    away = json['away'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['home'] = this.home;
    data['away'] = this.away;
    return data;
  }
}

class Periods {
  int? first;
  int? second;

  Periods({this.first, this.second});

  Periods.fromJson(Map<String, dynamic> json) {
    first = json['first'];
    second = json['second'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['first'] = this.first;
    data['second'] = this.second;
    return data;
  }
}

class Venue {
  int? id;
  String? name;
  String? city;

  Venue({this.id, this.name, this.city});

  Venue.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    name = json['name'];
    city = json['city'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['name'] = this.name;
    data['city'] = this.city;
    return data;
  }
}

//here we will store the Status
class Status {
  String? long;
  String? short;
  int? elapsed;

  Status({this.long, this.short, this.elapsed});

  Status.fromJson(Map<String, dynamic> json) {
    long = json['long'];
    short = json['short'];
    elapsed = json['elapsed'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['long'] = this.long;
    data['short'] = this.short;
    data['elapsed'] = this.elapsed;
    return data;
  }
}

class League {
  int? id;
  String? name;
  String? country;
  String? logo;
  String? flag;
  int? season;
  String? round;

  League(
      {this.id,
      this.name,
      this.country,
      this.logo,
      this.flag,
      this.season,
      this.round});

  League.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    name = json['name'];
    country = json['country'];
    logo = json['logo'];
    flag = json['flag'];
    season = json['season'];
    round = json['round'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['name'] = this.name;
    data['country'] = this.country;
    data['logo'] = this.logo;
    data['flag'] = this.flag;
    data['season'] = this.season;
    data['round'] = this.round;
    return data;
  }
}

class Home {
  int? id;
  String? name;
  String? logo;
  bool? winner;

  Home({this.id, this.name, this.logo, this.winner});

  Home.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    name = json['name'];
    logo = json['logo'];
    winner = json['winner'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['name'] = this.name;
    data['logo'] = this.logo;
    data['winner'] = this.winner;
    return data;
  }
}
